
###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.1 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import default__class_init__
from DateTime import DateTime
import Acquisition
import AccessControl.Role
import OFS.Folder
import base_item

calendar_event_add_redirect = HTMLFile('calendar_event_add_redirect', globals())
manage_add_calendar_event_form = HTMLFile('calendar_event_add', globals())


def manage_add_calendar_event(self, id, title, note, start, end, due, priority,
							  status, REQUEST=None):
    "Add an instance of the calendar_event class"
	
    self._setObject(id, calendar_event(id, title, note, start, end, due, priority, status))

    if REQUEST is not None:

        return self.manage_main(self, REQUEST)


class calendar_event(
	OFS.Folder.Folder,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	base_item.base_item
	):
	"Documentation string"

	meta_type = 'CalendarEvent'
	icon = 'misc_/Calendar/Folder_icon.gif'

	_properties = (
		{'id':'title', 'type':'string'},
		{'id':'note', 'type':'text'},
		{'id':'start', 'type':'date'},
		{'id':'end', 'type':'date'},
		{'id':'due', 'type':'date'},
		{'id':'priority', 'type':'int'},
		{'id':'status', 'type':'int'},
		)

	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('View CalendarEvents',
		 ('',)),
		)

	index_html = HTMLFile('calendar_event_index', globals())


	def __init__(self, id, title='', note='', start='2000-01-01', end='2000-01-01',
				 due='2000-01-01', priority='0', status='0'):
		"Initialize the class instance"
		
		self.id = id
		self.title = title
		self.note = note
		self.start = DateTime(start)
		self.end = DateTime(end)
		self.due = DateTime(due)
		self.priority = priority
		self.status = status


default__class_init__(calendar_event)

